<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Chomsky!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>

    <section>
        <title>Encoding</title>
        <para><emphasis>Fordítsuk le és futtassuk a Javat tanítok könyv MandelbrotHalmazNagyító.java
                forrását úgy, hogy a fájl nevekben és a forrásokban is meghagyjuk az ékezetes
                betűket!</emphasis></para>
        <para> Megoldás forrása: <link
                xlink:href="https://www.tankonyvtar.hu/hu/tartalom/tkt/javat-tanitok-javat/adatok.html"
            /></para>
        <para>Mandelbrot Halmaz. Majdnem egy egész leckét szántunk rá az előző félévben, szóval elég
            sok mindent tudunk már erről a biológia tematikájú jelenségről. Ehhez érdemes
            visszanézned a Mandelbrot csokorhoz, hogy kicsit felfrissítsd a tudásodat róla, bár
            ehhez a feladathoz konkrétan nem lesz szükséged vele kapcsolatban elméleti tudásra.
            Sokkal inkább kicsit a karakter kódolással fogunk megismerkedni. Maga a karakterkódolás
            során betűket, számokat és más hasonló adatokat jelenítünk meg úgy, hogy egy
            karaktergyűjteményben minden karakterhez valamilyen számot rendelünk, például ASCII
            kódolásban az A betű kódja a 65-ös vagy a B-nek a 66-os. Nagyon sok karakterkódolási
            rendszer létezik a világon, a legnépszerűbbek talán az ASCII, az ISO 8859, a Windows
            karakterkészlet és az Unicode. Az utóbbiban belül a jelenleg leggyakrabban használt az
            UTF-8, ma már minden weboldalt ebben a kódolásban publikálunk, mert minden Unicode
            karaktert tartalmaz, illetve visszafelé a 7 bites ASCII szabvánnyal is kompatibilis. </para>
        <para>A mi feladatunk jelenleg az, hogy a MandelbrotHalmazNagyító.java programunkat
            lefuttassuk, de ha ezt megtesszük, hibákat fog visszaadni nekünk a terminál, méghozzá az
            ékezetes betűk miatt. Linuxon dolgozva tudjuk, hogy az alapértelmezett kódolás az UTF-8,
            amivel nem fordul le a programunk, így a feladat az, hogy másik karakterkészlettel
            futtassuk le a kódot. Nem kell nagy dologra gondolni, ha a terminálba beírjuk a
                <code>man javac</code> parancsot, akkor ki is adja nekünk a parancshoz tartozó
            kapcsolókat. Köztük megtaláljuk az <code>encoding</code> szót is, ami pontosan ezért
            lesz felelős, ő a megoldásunk a problémára! De mégis milyen kódolást válasszak? Mikor a
            megfelelőt válasszuk, figyelnünk kell azt is, hogy a nyelvünk a Föld melyik részén
            helyezkedik el, jelen esetünkben a magyar nyelv egy nyugat-európai nyelv, és ha utána
            nézünk akár Wikipédián, meg is kapjuk a megfelelő kódolást: Windows-1252, vagy másnéven
            CP-1252. Az én esetemben az utóbbi formátum nem hozott sikert, az előbbi viszont igen. </para>
        <para>Azt már tudjuk, hogy a nagyító magától nem fog működni, szüksége van a szülő elemére,
            így a MandelbrotHalmaz.java és a MandelbrotHalmazNagyító.java fájlra is szükségünk van a
            megfelelő alkalmazásért. Ezután fordítsuk le és futtassuk le őket: </para>
        <para>
            <programlisting>> javac -encoding Windows-1252 *.java
> java MandelbrotHalmazNagyító</programlisting>
        </para>
        <para>Ezzel a megoldással a mappában lévő összes Java fájlt ebben a kódolásban fordítottunk
            le (így érdemes ezt a két fájlt külön mappába elhelyzeni), hogy a sima
            MandelbrotHalmaz.java is jó formátumban működjön, majd lefuttattuk őket, így már működni
            is fog nekünk a programunk. Ez egyébként egy olyan probléma, ami bár kisebb projekteknél
            nem feltétlenül fordul elő, előbb vagy utóbb minden programozó belefut már kódolási
            problémába, így érdemes ezzel tisztában lenni. </para>
        <para>És íme a használt MandelbrotHalmazNagyító.java forrása: </para>
        <para>
            <programlisting>/*
 * MandelbrotHalmazNagyító.java
 *
 * DIGIT 2005, Javat tanítok
 * Bátfai Norbert, nbatfai@inf.unideb.hu
 *
 */
/**
 * A Mandelbrot halmazt nagyító és kirajzoló osztály.
 *
 * @author Bátfai Norbert, nbatfai@inf.unideb.hu
 * @version 0.0.2
 */

public class MandelbrotHalmazNagyító extends MandelbrotHalmaz {
    private int x, y;
    private int mx, my;
    public MandelbrotHalmazNagyító(double a, double b, double c, double d,
        int szélesség, int iterációsHatár) {
        super(a, b, c, d, szélesség, iterációsHatár);
        setTitle("A Mandelbrot halmaz nagyításai");
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent m) {
                x = m.getX();
                y = m.getY();
                if(m.getButton() == java.awt.event.MouseEvent.BUTTON1 ) {
                    mx = 0;
                    my = 0;
                    repaint();
                } else {
                    MandelbrotIterációk iterációk =
                            new MandelbrotIterációk(
                            MandelbrotHalmazNagyító.this, 50);
                    new Thread(iterációk).start();
                }
            }
            public void mouseReleased(java.awt.event.MouseEvent m) {
                if(m.getButton() == java.awt.event.MouseEvent.BUTTON1 ) {
                    double dx = (MandelbrotHalmazNagyító.this.b
                            - MandelbrotHalmazNagyító.this.a)
                            /MandelbrotHalmazNagyító.this.szélesség;
                    double dy = (MandelbrotHalmazNagyító.this.d
                            - MandelbrotHalmazNagyító.this.c)
                            /MandelbrotHalmazNagyító.this.magasság;
                    new MandelbrotHalmazNagyító(
                            MandelbrotHalmazNagyító.this.a+x*dx,
                            MandelbrotHalmazNagyító.this.a+x*dx+mx*dx,
                            MandelbrotHalmazNagyító.this.d-y*dy-my*dy,
                            MandelbrotHalmazNagyító.this.d-y*dy,
                            600,
                            MandelbrotHalmazNagyító.this.iterációsHatár);
                }
            }
        });
        addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent m) {
                mx = m.getX() - x;
                my = m.getY() - y;
                repaint();
            }
        });
    }
    public void pillanatfelvétel() {
        java.awt.image.BufferedImage mentKép =
                new java.awt.image.BufferedImage(szélesség, magasság,
                java.awt.image.BufferedImage.TYPE_INT_RGB);
        java.awt.Graphics g = mentKép.getGraphics();
        g.drawImage(kép, 0, 0, this);
        g.setColor(java.awt.Color.BLACK);
        g.drawString("a=" + a, 10, 15);
        g.drawString("b=" + b, 10, 30);
        g.drawString("c=" + c, 10, 45);
        g.drawString("d=" + d, 10, 60);
        g.drawString("n=" + iterációsHatár, 10, 75);
        if(számításFut) {
            g.setColor(java.awt.Color.RED);
            g.drawLine(0, sor, getWidth(), sor);
        }
        g.setColor(java.awt.Color.GREEN);
        g.drawRect(x, y, mx, my);
        g.dispose();
        StringBuffer sb = new StringBuffer();
        sb = sb.delete(0, sb.length());
        sb.append("MandelbrotHalmazNagyitas_");
        sb.append(++pillanatfelvételSzámláló);
        sb.append("_");
        sb.append(a);
        sb.append("_");
        sb.append(b);
        sb.append("_");
        sb.append(c);
        sb.append("_");
        sb.append(d);
        sb.append(".png");
        try {
            javax.imageio.ImageIO.write(mentKép, "png",
                    new java.io.File(sb.toString()));
        } catch(java.io.IOException e) {
            e.printStackTrace();
        }
    }
    public void paint(java.awt.Graphics g) {
        g.drawImage(kép, 0, 0, this);
        if(számításFut) {
            g.setColor(java.awt.Color.RED);
            g.drawLine(0, sor, getWidth(), sor);
        }

        g.setColor(java.awt.Color.GREEN);
        g.drawRect(x, y, mx, my);
    }  
    public int getX() {
        return x;
    }   
    public int getY() {
        return y;
    }
    public static void main(String[] args) {
        new MandelbrotHalmazNagyító(-2.0, .7, -1.35, 1.35, 600, 255);
    }
}</programlisting>
        </para>
    </section>

    
    <section>
        <title>l334d1c4</title>
        <para><emphasis>Írj olyan OO Java vagy C++ osztályt, amely leet cipherként működik, azaz
                megvalósítja ezt a betű helyettesítést: <link
                    xlink:href="https://simple.wikipedia.org/wiki/Leet"/>. (Ha ez első részben nem
                tetted meg, akkor írasd ki és magyarázd meg a használt struktúratömb
                memóriafoglalását!) </emphasis></para>
        <para>A feladattal már találkoztunk egyszer, az első félévben is meg kellett már valósítani
            egy leet cipherként működő lexert, de akkor csak C nyelven. A jelenlegi feladatunk, hogy
            azt a programot megvalósítsuk vagy Java vagy C++ nyelven úgy, hogy objektumokat
            használunk. Emlékszel még, mi is a célja a programnak? Az, hogy ha beírunk bármilyen
            szót, akkor a programunk le fogja fordítani erre a nyelvre, tehát bizonyos karaktereket
            lecserék egy teljesen másmilyenre, például számra, de lehet egy karakter (pl. kerek
            zárójel) vagy egy teljesen más betű is. Titkos szövegként működik, amit első olvasásra
            nem lehet megérteni, életidegen nyelvnek tűnik. Ennek ellenére mégis létezik, eredetileg
            hackerek fejlesztették ki, hogy a tartalomszűrők ne találják meg őket és ne érthessék
            meg azt, amiről beszélnek, és hogy mire készülhetnek. </para>
        <para>Íme a C++-os implementációnk: </para>
        <para>
            <programlisting>#include &lt;iostream>
#include &lt;string>
#include &lt;cstring>

using namespace std;

    void enterGameLoop();
    string askWord(string prompt);
    string convertWord(string word);

    string word = " ";
    string again = "n";

    string alphabet= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    string leet[62]={"4","8","(","D","3","F","9","H","I","J","K",
    "1","M","N","0","P","9","R","5","7","U","V","W","X","Y","2",
    "4","b","(","d","3","f","9","h","i","j","k","l","m","n","0",
    "p","q","r","5","7","u","v","w","x","y","2","O","I","Z","E","h","S","b","T","X","g"};

int main() {
    enterGameLoop();
    return 0;
}

void enterGameLoop() {
    do {
    word = askWord("\n\nIrja be a forditando szoveget.\n\n>");
    word = convertWord(word);
    cout &lt;&lt; word &lt;&lt; "\n\nAkarsz uj szut beirni? (i/n)?\n\n>";
    getline(cin,again);
    }

    while(again == "i");
}
string askWord(string prompt) {
       string word;
       cout &lt;&lt; prompt;
       getline(cin,word);
       cout &lt;&lt; "\n\n" &lt;&lt; word &lt;&lt; " -> ";
       return word;
}

string convertWord(string word) {
    for(size_t i = 0; i &lt; word.size(); i++) {
        for(int j = 0; j &lt; 62; j++) {
           if(word[i] == alphabet[j])
        word.replace(i, leet[j].size(), leet[j]);
        }
    }

      return word;
}</programlisting>
        </para>
        <para>
            <programlisting>int main() {
    enterGameLoop();
    return 0;
}</programlisting>
        </para>
        <para>A program elején deklaráltuk a függvényeket, a globális változókat és a két abc-nek, a
            hagyományost és a leet betűket. Ezután a <function>main()</function>-ben csak a
            programunk ciklusát helyeztük el, ami addig fog működni, amíg van szó, amit lefordíthat.
            Ezt a függvényt csak ezután írtuk meg, de ez nem probléma, a nyelv így is érzékeli majd. </para>
        <para>
            <programlisting>void enterGameLoop() {
    do {
    word = askWord("\n\nIrja be a forditando szoveget.\n\n>");
    word = convertWord(word);
    cout &lt;&lt; word &lt;&lt; "\n\nAkarsz uj szut beirni? (i/n)?\n\n>";
    getline(cin,again);
    }

    while(again == "i");
}</programlisting>
        </para>
        <para>És a ciklusunk. Bekérünk egy szót, közben meghívjuk az <function>askWord()</function>
            függvényt, ami pontosan azért fog csak felelni, hogy bekérjen tőlünk egy szót, amit le
            szeretnénk fordítani leet nyelvre. Ezután meghívjuk a <function>convertWord()</function>
            függvényt, ő fog a fordításért felelni, majd fenntartjuk a lehetőséget arra, hogy még
            írhassunk be szót fordítás céljára. Ha a válasz nem, akkor nyilván a ciklusunk leáll és
            a programunknak is vége, de a válasz "i" volt, akkor újra kezdődik a ciklus, és ismét
            beírhatunk szöveget. Illetve természetesen kiíratjuk az előzőnek a fordítását. </para>
        <para>
            <programlisting>string askWord(string prompt) {
       string word;
       cout &lt;&lt; prompt;
       getline(cin,word);
       cout &lt;&lt; "\n\n" &lt;&lt; word &lt;&lt; " -> ";
       return word;
}

string convertWord(string word) {
    for(size_t i = 0; i &lt; word.size(); i++) {
        for(int j = 0; j &lt; 62; j++) {
           if(word[i] == alphabet[j])
        word.replace(i, leet[j].size(), leet[j]);
        }
    }

      return word;
}</programlisting>
        </para>
        <para>A két függvényünk. Az <function>askWord()</function>-ről már tudjuk, hogy bekéri a
            szöveget, amit le szeretnénk fordítani és ki is íratja, hogy biztosak legyünk benne,
            valóban azt írtuk be. A <function>convertWord()</function> pedig a fordításért felelős.
            A működése úgy történik, hogy végig megy a szó hosszán, illetve egy belső for ciklussal
            még 62-ig, ugyanis ennyi karakterünk van. Ha szó i-edik karaktere megegyezik a rendes
            ábécé j-edik karakterével, tehát értelmezhető betát talált, akkor a szó i-edik elemét
            cserélje le méghozzá a leet -jedik elemére. </para>
    </section>
    
    <section>
        <title>Full screen</title>
        <para><emphasis>Készítsünk egy teljes képernyős Java programot!</emphasis></para>
        <para>A GUI szóval már találkoztunk a könyv folyamán, de soha nem mélyedtünk igazán bele,
            hogy mit is jelent, mit hoz magával, milyen elemekből épül fel és a többi. A GUI az a
            Graphical User Interface rövidítése, magyarul grafikus felhasználói felületet,
            interfészt jelent. Célja, hogy a monitor képernyőjén szöveges és rajzos elemek
            jelenjenek meg, tehát grafikus felületet hozzunk létre a pprogramunknak. Két verziója
            létezik: Abstract Windowing Toolkit (nehézsúlyú) és Swing (pehelysúlyú komponensek). Az
            előbbi platform független, míg az utóbbi a Java nyelvben használatos. Mivel a mi
            feladatunk, hogy egy Java programot írjunk, így a Swing-gel fogunk kicsit megismerkedni. </para>
        <para>Egy GUI programban használunk konténereket, komponenseket, elrendezéseket és
            eseménykezelőket (például a Mandelbrot Halmazt megvalósító program nagyításakor is
            találkoztunk ilyennel). Maguk a konténerek alkotják a programnak a keretet, felületet a
            további elemeknek, egyfajta "vászonként" viselkednek. Itt helyezhetjük el a többi belső
            elemet. Az elrendezések a komponensek stratégia szerinti elhelyezése érdekében
            használatosak, ez nagyon is fontos, hogy átlátható és jól működő programunk legyen.
            Amúgy is, ma már csak azt tudunk igazán elsimerni jó programnak, ami tudatosan és
            átláthatóan van megírva. </para>
        <para>A konténerhez tudunk hozzáadni olyan komponenseket, mint például a JFrame, ami az
            ablak méretéért felelős (ezzel tudjuk majd megvalósítani a teljes képernyős módot) vagy
            akár a JPanel, JWindow és a többi. Amit észrevehetsz, hogy mindegyik előtt egy J betű
            szerepel. Ez nem véletlen, ez mindegyik elemnek, osztálynak a közös prefixe, innen
            tudjuk, hogy grafikai felület részeiről van szó. Tudunk bizonyos dolgokat is beállítani,
            mint az ablaknak a címe (setTitle), mérete (setSize), pozíció, hogy hol jelenjen meg
            maga az ablak (setLocation, jegyezd meg a teljes képernyős módhoz) és még sok más.
            Népszerű komponensek mondjuk a gombok (JButton), a szövegek (JLabel), a szövegdobozok
            (JTextField, csak sztringekhez), sőt vannak kiválasztható elemek is, például mikor
            választani kell, hogy a kitöltő nő vagy férfi, esetleg több elemet is kiválaszthat. Van
            legördülő menü is, de a paletta elég széles, sokáig lehetne sorolni. Az elrendezések is
            sokfélék lehetnek, van például GridLayout, GridBagLayout, FlowLayout stb. Az
            eseménykezelők közül pedig főleg nagy választék van, van az ún. ActionListener,
            MouseListener (ezzel már találkoztunk), KeyListener, és még sokan mások. De ha többet
            szeretnél tudni, ezen a linken bővebben olvashatsz a komponensek, elrendezések és
            eseménykezelők után: <link
                xlink:href="https://docs.oracle.com/javase/tutorial/uiswing/index.html"/>.</para>
        <para>Mivel a feladat nem mondta meg, milyen program kell, válasszunk egy színkeverőt. A
            program lényege, hogy a három RGB színnel: piros, zöld és kék - ezekkel keverjük ki a
            nekünk kellő színeket. És majd ezt kell teljes képernyőre állítanunk. Ahhoz, hogy amúgy
            az egész grafikai programunk működjön és majd a full screent is megvalósíthassuk,
            importálnunk kell a <code>javax.swing</code> és <code>java.awt</code> csomagokat. És
            akkor nézzük a kódunkat: </para>
        <para>
            <programlisting>import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class ColorSlide extends JFrame implements ChangeListener {
    ColorPanel canvas = new ColorPanel();
    JSlider red = new JSlider(0, 255, 255);
    JSlider green = new JSlider(0, 255, 0);
    JSlider blue = new JSlider(0, 255, 0);
    
    public ColorSlide(){
        super("Színkeverő");
        setExtendedState(JFrame.MAXIMIZED_BOTH); 
        setUndecorated(true);
        setVisible(true);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
        
        red.setMajorTickSpacing(50);
        red.setMinorTickSpacing(10);
        red.setPaintTicks(true);
        red.setPaintLabels(true);
        red.addChangeListener(this);
        
        green.setMajorTickSpacing(50);
        green.setMinorTickSpacing(10);
        green.setPaintTicks(true);
        green.setPaintLabels(true);
        green.addChangeListener(this);
        
        blue.setMajorTickSpacing(50);
        blue.setMinorTickSpacing(10);
        blue.setPaintTicks(true);
        blue.setPaintLabels(true);
        blue.addChangeListener(this);
        
        JLabel redLabel = new JLabel("Red: ");
        JLabel greenLabel = new JLabel("Green: ");
        JLabel blueLabel = new JLabel("Blue: ");
        GridLayout grid = new GridLayout(4,1);
        FlowLayout right = new FlowLayout();
        setLayout(grid);
        
        JPanel redPanel = new JPanel();
        redPanel.setLayout(right);
        redPanel.add(redLabel);
        redPanel.add(red);
        add(redPanel);
        
        JPanel greenPanel = new JPanel();
        greenPanel.setLayout(right);
        greenPanel.add(greenLabel);
        greenPanel.add(green);
        add(greenPanel);
        
        JPanel bluePanel = new JPanel();
        bluePanel.setLayout(right);
        bluePanel.add(blueLabel);
        bluePanel.add(blue);
        add(bluePanel);
        add(canvas);
        
        setVisible(true);
        
    }
    public void stateChanged(ChangeEvent evt){
        JSlider source = (JSlider)evt.getSource();
        if(source.getValueIsAdjusting() != true) {
            Color current = new Color(red.getValue(),
            green.getValue(), blue.getValue());
            canvas.changeColor(current);
            canvas.repaint();
        }
    }
    
    public Insets getInsets() {
        Insets border = new Insets(45, 10, 10, 10);
        return border;
    }

    public static void main(String[] args){
        ColorSlide cs = new ColorSlide();
    }

}
        
class ColorPanel extends JPanel {
    Color background;
    
    ColorPanel() {
        background = Color.red;
    }

    public void paintComponent(Graphics comp) {
        Graphics2D comp2D = (Graphics2D)comp;
        comp2D.setColor(background);
        comp2D.fillRect(0,0, getSize().width, getSize().height);    
    }
    
    void changeColor(Color newBackground) {
        background = newBackground;
    }
}   </programlisting>
        </para>
        <para>És akkor pár dologról beszéljünk kicsit, hogy mi mit is jelent a forráskódban, így
            sokkal érthetőbb lesz, mert valószínűleg kicsit sok és érthetetlen lehet számunkra a
            dolog: </para>
        <para>
            <programlisting>public class ColorSlide extends JFrame implements ChangeListener {
    ColorPanel canvas = new ColorPanel();
    JSlider red = new JSlider(0, 255, 255);
    JSlider green = new JSlider(0, 255, 0);
    JSlider blue = new JSlider(0, 255, 0);
    
    public ColorSlide(){
        super("Színkeverő");
        setExtendedState(JFrame.MAXIMIZED_BOTH); 
        setUndecorated(true);
        setVisible(true);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);</programlisting>
        </para>
        <para>Létrehoztunk a vásznunkat (canvas) és a három szín példányunkat, a pirost, zöldet és
            kéket, ezeknek a megfelelő színkódot adtuk meg, ami így az alapértelmezett lett. Majd a
            konstruktorba lépünk be, itt a <code>super("Színkeverő")</code> az ablaknak a nevét adja
            meg, így azt bármikor nyugodtan át lehet írni tetszőlegesre. A többi beállítás a
            képernyőfelbontásért felel, illetve azért, hogy full screen legyen a
                <code>JFrame.MAXIMIZED_BOTH</code> felelős. A <function>setUndecorated()</function>
            függvénnyel tudjuk megmondani, hogy a keretet kikapcsoljuk, a
                <function>setVisible()</function> pedig szabályozza, hogy az összetevő és annak
            gyerekei megjelenjenek-e a képernyőn. A mi esetünkben igen. A
                <function>setDefaultCloseOperation()</function> függvény a bezárás gombnak ad
            funkciót, ez többféle is lehet, jelenleg a program bezárásáért felel, de lehetne az,
            hogy csak elrejti a programot, vagy hogy ignorálja a kattintást. </para>
        <para>
            <programlisting>        red.setMajorTickSpacing(50);
        red.setMinorTickSpacing(10);
        red.setPaintTicks(true);
        red.setPaintLabels(true);
        red.addChangeListener(this);</programlisting>
        </para>
        <para>Most csak a piros színt emelném ki, hiszen a következő zöld és kék tömbnél ugyanazok
            lesznek, felesleges bemásolni, ismételni a dolgot. A
                <function>setMajorTickSpacing()</function> és
                <function>setMinorTickSpacing()</function> nem feltétlenül szükségesek, de
            elegánsabbak és nagy segítséget nyújtank a felhasználónak. Ahogy a képen is láthatjuk, a
            vízszintes vonalakon (vagyis csuszkákon) függőleges kisebb és nagyobb vonalat is látunk.
            Ezek a jelölések, amiknek a mértéket tudjuk ezzel a függvénnyel meghatározni. Vannak
            hosszabbb és rövidebb jelölések, nyilván a hosszabbak egy nagyobb értéket is jelölnek,
            például kerek számokat. Ezeket a jelöléseket a <function>setPaintTicks()</function> és a
                <function>setPaintLabels()</function> függvényekkel tudtuk bekapcsolni. </para>
        <para>
            <programlisting>        JLabel redLabel = new JLabel("Red: ");
        JLabel greenLabel = new JLabel("Green: ");
        JLabel blueLabel = new JLabel("Blue: ");
        GridLayout grid = new GridLayout(4,1);
        FlowLayout right = new FlowLayout();
        setLayout(grid);</programlisting>
        </para>
        <para>A <code>JLabel</code> a szöveges elemért felel, ezekkel hoztuk létre a piros, zöld és
            kék feliratokat a programban, majd létrehoztunk két elrendezést is, egy rács és flow
            elrendezést. A kettő között az a különbség, hogy a grid olyasmi, mintha egy több
            oszlopos és soros elrendezést hoznánk létre, ezzel szemben a flow-ban egymás mellett
            helyezkednek el az elemek, tehát egy több oszlopos, de csak egy soros layout. </para>
        <para>
            <programlisting>        JPanel redPanel = new JPanel();
        redPanel.setLayout(right);
        redPanel.add(redLabel);
        redPanel.add(red);
        add(redPanel);</programlisting>
        </para>
        <para>Ez a rész ugyanígy ismétlődik a zöld és kék szín esetében is. Ekkor hozzuk létre a
            JPanel-t, egyfajta dobozkát, amit mi nem látunk, de abba tesszük bele a színeket,
            azoknak minden elemével együtt. Elhelyezzük őket és hozzáadjuk a szöveget, a csuszkát. </para>
        <para>
            <programlisting>    public void stateChanged(ChangeEvent evt){
        JSlider source = (JSlider)evt.getSource();
        if(source.getValueIsAdjusting() != true) {
            Color current = new Color(red.getValue(),
            green.getValue(), blue.getValue());
            canvas.changeColor(current);
            canvas.repaint();
        }
    }

    public Insets getInsets() {
        Insets border = new Insets(45, 10, 10, 10);
        return border;
    }

    public static void main(String[] args){
        ColorSlide cs = new ColorSlide();
    }</programlisting>
        </para>
        <para>A függvény azért felel, hogy programunk alsó részét, ahol a vásznunk van, befessük. A
                <function>repaint()</function> függvény ismerős lehet, nem véletlenül, előző
            félévben használtuk már például a Mandelbrot-os feladatoknál. Ez a befestés ez függ a
            zöld, kék és piros értékeitől, így jön létre a <code>current</code>, vagyis a jelenlegi
            szín, amire festi a program a <code>canvas</code>-t. Az <code>Insets</code> metódus egy
            tároló szélét ábrázolja, ez lehet keret, üres hely vagy cím, a mi esetünkben keretről
            van szó, ami azt mondja meg, hogy felülről 45, a többi oldalról pedig 10-et hagyjon ki.
            A <function>main()</function>-ben csak példányosítottunk. </para>
        <para>
            <programlisting>class ColorPanel extends JPanel {
    Color background;
    
    ColorPanel() {
        background = Color.red;
    }

    public void paintComponent(Graphics comp) {
        Graphics2D comp2D = (Graphics2D)comp;
        comp2D.setColor(background);
        comp2D.fillRect(0,0, getSize().width, getSize().height);    
    }
    
    void changeColor(Color newBackground) {
        background = newBackground;
    }
}   </programlisting>
        </para>
        <para>A programunk utolsó része, amivel piros hátteret állítottunk be a
                <code>ColorPanel</code>-ünknek, ez az alapértelmezett, ha elindítjuk a programunkat,
            akkor látni is fogjuk. A végén lévő <function>changeColor()</function> metódus fogja
            megváltoztatni a háttérszínt, mikor a csuszkákon dolgozunk majd. A kettő közötti
                <function>paintComponent()</function> pontosan ezért felelős, egy fajta szükséges
            elem, hogy az újrafestést meg tudjuk valósítani. </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="1.2.4csokor/colorslide.png" scale="33"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
    </section>


    <section>
	<title>Perceptron osztály</title>
	<para><emphasis>Dolgozzuk be egy külön projektbe a projekt Perceptron osztályát!</emphasis></para>
	<para>Megoldás forrása: <link xlink:href="https://www.youtube.com/watch?v=XpBnR31BRJY"/></para>
        <para>Egy újabb olyan feladat, amivel már foglalkoztunk az előző félévben. A Caesar
            csokorban beszéltünk a neurális hálókról és a hiba-visszaterjesztéses perceptronról,
            azok kapcsolatáról. Emlékszel még a kis ovális képre, a neuronok matematikai hátterére?
            Tudod, azzal magyaráztuk meg, hogy a bemenetről érkeznek a számok, amik súllyal
            rendelkeznek és minden számot ezzel a súllyal adunk össze a bemeneti függvénnyel. Aztán
            az aktivációs függvény ezeket az értékeket manipulálja, majd a továbbadás döntését az
            adja meg, hogy a kapott súlyozott összeg átlép-e egy küszöböt.  És mi a helyzet a
            Perceptronnal? Egy bemeneti és egy kimeneti neurális hálóból áll, és mikor a
            hiba-visszaterjesztés volt a cél, akkor még egy rejtett rétegünk is volt, pontosan a
            bemeneti és a kimeneti réteg között, mint egy extre Perceptron. </para>
        <para>Nem kell sok mindent csinálnunk most, a feladatunk csupán az, hogy a Perceptron
            osztályunkat egy külön projektbe integráljuk bele, de ettől függetlenül még maga a
            program pontosan azt fogja csinálni, mint tavaly, ugyanolyan eredményt kell kapnunk. Íme
            a forráskódok: <link
                xlink:href="/1.2.4csokor/main2.cpp"><filename>main2.cpp</filename></link>, <link
                xlink:href="/1.2.4csokor/mandelpng.cpp"><filename>mandelpng.cpp</filename></link> és <link
                xlink:href="/1.2.4csokor/perceptron.hpp"><filename>perceptron.hpp</filename></link>.</para>
        <para>A fordítás és a futtatás is ugyanúgy működik, az <code>-lpng</code> kapcsolót is
            továbbra is használjuk, hogy a png képet le tudjuk generálni. Ha esetleg nem használtad
            volna még, akkor a <code>sudo apt-get install libpng++-dev</code> paranccsal tudod
            telepíteni a terminálban, ezután fogod tudni használni. </para>
        <para>
            <programlisting>> g++ -o mandel mandel.cpp -lpng
> ./mandel mandel.png
> g++ perceptron.hpp main2.cpp -o main2 -lpng -std=c++11
> ./main2 mandel.png</programlisting>
        </para>
        <para>És íme a végeredmények: </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="1.2.4csokor/1.png" scale="40"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="1.2.4csokor/2.png" scale="40"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
    </section>
</chapter>                
